unit StorageTree;

interface

uses
  VectoredGraph,
  PoifsWithRepair;

type
  TStorageElement = class(TAbstractGraphNode)
  private
    FData: TPoifsProperty;
    FAdded: Boolean;
  public
    property Data: TPoifsProperty read FData write FData;
    property Added: Boolean read FAdded write FAdded;
  end;

  TStorageTree = class(TAbstractGraph)
  protected
    function GetNodeClass: TAbstractGraphNodeClass; override;
  public
    function AddNode(const ID: Integer): TStorageElement; reintroduce;
    function GetNode(const Index: Integer): TStorageElement; reintroduce;
  end;

implementation

{ TStorageTree }

function TStorageTree.AddNode(const ID: Integer): TStorageElement;
begin
  Result := TStorageElement(inherited AddNode(ID));
end;

function TStorageTree.GetNode(const Index: Integer): TStorageElement;
begin
  if Index >= NodesCount then
    Result := nil
  else
    Result := TStorageElement(inherited GetNode(Index));
end;

function TStorageTree.GetNodeClass: TAbstractGraphNodeClass;
begin
  Result := TStorageElement;
end;

end.
