////////////////////////////////////////////////////////////////////////////////
//
//  ****************************************************************************
//  * Project   :  -   Compound File
//  * URL       : http://alexander-bagel.blogspot.ru/2015/03/compound-file.html
//  * Unit Name : StorageCreateDemo
//  * Purpose   :   
//  * Author    :  (Rouse_) 
//  * Copyright :  Fangorn Wizards Lab 1998 - 2015.
//  * Version   : 1.0
//  * Home Page : http://rouse.drkb.ru
//  * Home Blog : http://alexander-bagel.blogspot.ru
//  ****************************************************************************
//

program StorageCreateDemo;

{$APPTYPE CONSOLE}

uses
  Windows,
  SysUtils,
  ActiveX,
  AxCtrls;

procedure CheckHResult(Code: HRESULT);
begin
  if not Succeeded(Code) then
    RaiseLastOSError;
end;

procedure WriteFile(Storage: IStorage; AName: WideString; Data: AnsiString);
var
  Stream: IStream;
  OS: TOleStream;
begin
  //    (     31    )
  CheckHResult(Storage.CreateStream(@AName[1],
    STGM_WRITE or STGM_SHARE_EXCLUSIVE,
    0, 0, Stream));

  //      
  OS := TOleStream.Create(Stream);
  try
    OS.WriteBuffer(Data[1], Length(Data));
  finally
    OS.Free;
  end;
end;

var
  TestFilePath: string;
  WideBuff: WideString;
  Root, Folder: IStorage;
  I: Integer;
begin
  TestFilePath := ExtractFilePath(ParamStr(0)) + '..\data\simple.bin';
  ForceDirectories(ExtractFilePath(TestFilePath));

  //   
  WideBuff := TestFilePath;
  CheckHResult(StgCreateDocfile(@WideBuff[1],
    STGM_CREATE or STGM_WRITE or STGM_SHARE_EXCLUSIVE,
    0, Root));

  //     
  WriteFile(Root, 'RootFile', 'First file data');

  //   
  CheckHResult(Root.CreateStorage('SubFolder',
    STGM_WRITE or STGM_SHARE_EXCLUSIVE,
    0, 0, Folder));

  //     
  WriteFile(Folder, 'SubFolderFile', 'Second file data');

  //   -   ,    
  CheckHResult(Root.Commit(STGC_DEFAULT));

  //      
  //     10 
//  for I := 0 to 9 do
//    WriteFile(Root, 'NotCommitedFile' + IntToStr(I), 'This data can not be commited ' + IntToStr(I));

  //   -   
  //CheckHResult(Root.Commit(STGC_DEFAULT));

//  Root := nil;

  WriteFile(Folder, 'SubFolderFile2', 'Second2 file data');

  Writeln('DONE');
  Readln;
end.
